/* Musical Blob
 * University of Washington Computer Science and Engineering
 * Sound Capstone (CSE 481i)
 * Project Members: Nathan Armstrong, Daniel Chesney, Andrew Foster
 *
 * BoundingBox
 * For documentation, see BoundingBox.hpp
 */

#include <algorithm>
#include "BoundingBox.hpp"

using std::min;
using std::max;

TripleD minTriple(const TripleD& a, const TripleD& b){
	return TripleD(min(a.getElemA(), b.getElemA()),
		           min(a.getElemB(), b.getElemB()),
				   min(a.getElemC(), b.getElemC()));
}

TripleD maxTriple(const TripleD& a, const TripleD& b){
	return TripleD(max(a.getElemA(), b.getElemA()),
		           max(a.getElemB(), b.getElemB()),
				   max(a.getElemC(), b.getElemC()));
}

BoundingBox::BoundingBox(const BoundingBox& a, const BoundingBox& b){
	minP = minTriple(a.getMinCorner(), b.getMinCorner());
	maxP = maxTriple(a.getMaxCorner(), b.getMaxCorner());
}

bool BoundingBox::intersects(const BoundingBox& o) const {
	TripleD boundDim = maxTriple(maxP, o.maxP) - minTriple(minP, o.minP);
	boundDim -= maxP - minP + o.maxP - o.minP;
	return boundDim.getElemA() < 0
		&& boundDim.getElemB() < 0
		&& boundDim.getElemC() < 0;
}