/* Musical Blob
 * University of Washington Computer Science and Engineering
 * Sound Capstone (CSE 481i)
 * Project Members: Nathan Armstrong, Daniel Chesney, Andrew Foster
 *
 * ParticleBoundSet
 * For documentation, see ParticleBoundSet.hpp
 */

#include <algorithm>
#include "ParticleBoundSet.hpp"

using std::min;
using std::max;

ParticleBoundSet::ParticleBoundSet(Particle* p, double margin){
	parts.push_back(p);
	TripleD marginTriple(margin, margin, margin);
	bounds = BoundingBox(p->getCurrPos() - marginTriple,
	                     p->getCurrPos() + marginTriple);
}

bool ParticleBoundSet::intersects(const ParticleBoundSet* const pbs) const {
	return bounds.intersects(pbs->bounds);
}

void ParticleBoundSet::mergeSubset(const ParticleBoundSet* const pbs){
	vector<Particle*>::const_iterator i;
	for(i = pbs->parts.begin(); i != pbs->parts.end(); i++)
		parts.push_back(*i);
	bounds = BoundingBox(bounds, pbs->bounds);
}
