
Server.default = s = Server.internal.boot;
(
var verbBus, inBus1, inBus2;
s.scope;
s.freqscope;


s.waitForBoot({
	verbBus = CtkAudio.new(server: s);
	inBus1 = Buffer.alloc(s, 44100 * 5, 1);
	inBus2 = Buffer.alloc(s, 44100 * 7, 1);

	b = Buffer.alloc(s, 1024);
	c = Buffer.alloc(s, 512);
	~stockbuf = CtkBuffer.playbuf("~/Documents/School/2011-2012/CSE\ 481\ I\ Sound\ Capstone/Clips/Clav-02.aiff".standardizePath).load;
	
	s.sync;
	~verb = CtkSynthDef(\reverb, {arg mix = 0.5, len = 5;
		var src, verbL, verbR;
		src = In.ar(verbBus);
		#verbL, verbR = GVerb.ar(src, 30, len, 0.3, drylevel: (1-mix));
		Out.ar(0, [verbL, verbR]);
	});
	
	~grainSynth = CtkSynthDef(\grannSynthomatic, {arg parX, parY, parZ, parImX, parImY, parImZ, 
									cenX, cenY, cenZ, cenImX, cenImY, cenImZ, 
									minBX, minBY, minBZ, maxBX, maxBY, maxBZ;
		var grainSigL, grainSigR, trigger, grainDur, carfreq, modfreq, index, pan, out, amplitude;
		trigger = Impulse.ar(100 * parImX);
		grainDur = (parImX + parImY + parImZ)/3;
		carfreq = (parY + 1).log * 3000;
		modfreq = (parImY - 0.5).abs * 50;
		index = (parImX) * 100;
		pan = (parX - 1) * 2 ;
		amplitude = 0;
	  #grainSigL, grainSigR = GrainFM.ar(2, trigger, grainDur, carfreq, modfreq, index, pan);
		Out.ar(verbBus, [grainSigL, grainSigR].sum * (((parX - 0.5).abs * 2)/100))/4;
	});

	
	~granulateIn = CtkSynthDef(\granulate, {arg parX, parY, parZ, parImX, parImY, parImZ, 
									cenX, cenY, cenZ, cenImX, cenImY, cenImZ, 
									minBX, minBY, minBZ, maxBX, maxBY, maxBZ;
		var granSigL, granSigR, trigBuff, grainDur, pan, in, out, onsets, cenImC, rate, pos, resetRate, exite;
		
		trigBuff = Impulse.ar((parImX + parImY + parImZ)/3 * (cenImX *50));
		grainDur = 3 / (cenX - parX).abs;
			
		rate	= (parY * 2);
			
	   cenImC = (cenImX + cenImY) * 2;
	   pos = (((parX - 0.5).abs * 2) * BufDur.kr(inBus1.bufnum)) * trigBuff;
	   in = SoundIn.ar(0);
	   
	   exite = (parImX + parImY + parImZ)/3;
	   
	   onsets = Onsets.kr(FFT(b, in), 0.8);
		resetRate = onsets;
		RecordBuf.ar(in, inBus1.bufnum, loop: 1, preLevel: 0.4, recLevel: exite, trigger: resetRate);		
		pan = 1 - (parX * 2);
		
		
	  #granSigL, granSigR = GrainBuf.ar(2, trigBuff, 1, inBus1, rate, pos, 2, pan);
		out = Out.ar(0, [granSigL, granSigR] * 0.2);
	});
	
	~stretch = CtkSynthDef(\stretchy, {arg parX, parY, parZ, parImX, parImY, parImZ, 
									cenX, cenY, cenZ, cenImX, cenImY, cenImZ, 
									minBX, minBY, minBZ, maxBX, maxBY, maxBZ;
		var stretchSigL, stretchSigR, trigBuff, grainDur, pan, in, out, onsets, freqShift, overlaps, pos, resetRate, exite, sig;
		
		trigBuff = Impulse.ar((parImX + parImY + parZ)/3 * (cenImX *100) + 2);
		grainDur = 2;
			
		overlaps	= 5;
			
	   	//freqShift = ((cenImX * cenImY * 2 + parY) + 0.5)*2;
	   	freqShift = (cenImX + parY) / 4 + 0.75;
	   	pos = (((parX - 0.5).abs * 2) * BufDur.kr(inBus2.bufnum)) * 1;
	   	in = SoundIn.ar(0);
	   
	   	exite = (parX * 100 );
	   
		RecordBuf.ar(in, inBus2.bufnum, loop: 1, preLevel: 0.4, recLevel: 1.4 );		
		pan = 1 - (parX * 2);
		
		sig = WarpZ.ar(1, inBus2, pos, freqShift, grainDur, -1, overlaps, 0.4, 2);
				//WarpZ.ar(2, trigBuff, pos, rate, windowSize, envbufnum, overlaps, 
		//windowRandRatio, interp, zeroSearch, zeroStart, mul, add)
		//out = Out.ar(verbBus, [granSigL, granSigR] * 003);
		out = Out.ar(0, Pan2.ar(sig * 0.05));
	});
	
	//Andrew's Synth

//	~bufs = List.new;
//	12.do({arg i;
//		var path, buf;
//		i = i+1;
//		path = "~/Documents/School/2011-2012/CSE\ 481\ I\ Sound\ Capstone/Clips".standardizePath;
//		path = path ++ "/Clav-" ++ (i/10).floor ++ (i%10) ++ ".aiff";
//		//path.postln;
//		buf = CtkBuffer.playbuf(path).load;
//		~bufs.add(buf);
//		//score.add(buf);
//	});
//	~bufs.removeAt(4);
//	~bufs.removeAt(5);
	
	
	
	
	~stock = CtkSynthDef(\stockSynth, {arg parX, parY = 0, parZ, parImX, parImY, parImZ, 
									cenX, cenY, cenZ, cenImX, cenImY, cenImZ, 
									minBX, minBY, minBZ, maxBX, maxBY, maxBZ;
		var ampEnv, buf, bufInd, player, pulse, jitter, numharms, filt, qt, freqs;
		var boost, fundFreq, filterFreq, bw, accelFact, harmMult, amp, out;
		boost = 10;
		//bufInd = (parY*7).floor;
		//buf = ~bufs[1];
		buf = ~stockbuf;
		player = PlayBuf.ar(1, buf, BufRateScale.kr(buf) * (1 + (parZ*3)), 
							(parImX+parImY+parImZ) - 1, loop: 0);
		fundFreq = (4 + ((parX*20).floor*4)).midicps;
		filterFreq = 10;
		bw = 100;
		accelFact = 4;
		harmMult = 0.4;
		//ampEnv = Env([-40, -35, -15, -10], [0.5, 1, 0.5], \sin);
		//amp = ampEnv.at(parY - cenY + 1);
		amp = (parY-cenY - 1.667) * 25;
		numharms = (SampleRate.ir * harmMult) / (fundFreq);
		jitter = WhiteNoise.kr(0.01, 0.995);
		pulse = Blip.ar(fundFreq*accelFact*jitter, numharms.floor, 1);
		qt = bw/(filterFreq*accelFact);
		filt = Resonz.ar(pulse, filterFreq*accelFact, qt, 2);
		out = filt * amp.dbamp * boost + player;
		Out.ar(verbBus, out);
	});
});
)

//////////////////////////////////////////////////////////////////////////////////////////////

(
var initialize;

initialize = {
	r = OSCresponderNode(nil, '/init', {arg time, resp, msg, addr;
		var nodeArray, synthArray, gsynth, global, initNum = msg[1], synthNum = msg[2], responder = 0, module;
		//msg.postln;
		nodeArray = Array.newClear(initNum);
		
		module = case
		
		{synthNum == 0}	{~verb.note.play;
						 synthArray = Array.fill(initNum, {~grainSynth.note.play})}
			 
		{synthNum == 1}	{synthArray = Array.fill(initNum, {~granulateIn.note.play})}

		{synthNum == 2}	{synthArray = Array.fill(initNum, {~stretch.note.play})}
		
		{synthNum == 3}    {~verb.note.play;
						 synthArray = Array.fill(initNum, {~stock.note.play})};
		
		//synthArray.postln;
		initNum.do({arg i; 
			var curName;
			curName = '/nodeMsg' ++ i.asString;
			curName = curName.asSymbol;
			responder = OSCresponderNode(nil, curName, {arg time, resp, msg, addr;
				var tag, parX, parY, parZ, parImX, parImY, parImZ;
				//msg.postln;
				#tag, parX, parY, parZ, parImX, parImY, parImZ = msg;
				synthArray[i].parX_(parX).parY_(parY).parZ_(parZ).parImX_(parImX).parImY_(parImY).parImZ_(parImZ);
			}).add;
			nodeArray.put(i, responder); 		
		});
		global = OSCresponderNode(nil, '/global', {arg time, resp, msg, addr;
			var tag, cenX, cenY, cenZ, cenImX, cenImY, cenImZ, minBX, minBY, minBZ, maxBX, maxBY, maxBZ;
			#tag, cenX, cenY, cenZ, cenImX, cenImY, cenImZ, minBX, minBY, minBZ, maxBX, maxBY, maxBZ= msg;
			//msg.postln;
			initNum.do({ arg i;
				synthArray[i].cenX_(cenX).cenY_(cenY).cenZ_(cenZ).cenImX_(cenImX).cenImY_(cenImY)
				.cenImZ_(cenImZ).minBX_(minBX).minBY_(minBY).minBZ_(minBZ).maxBX_(maxBX).maxBY_(maxBY).maxBZ_(maxBZ);
			})
		}).add;
		OSCresponderNode(nil, '/clear', {arg time, resp, msg, addr;
			initNum.do({arg i;
				var theNode;
				~verb.free;
				theNode = nodeArray[i];
				theNode.class.postln;
				synthArray[i].free;
				theNode.remove;
			});
			global.remove;
			initialize.value;
		}).add.removeWhenDone;
	}).add(s).removeWhenDone;
};

initialize.value;
)

///////////////////////////////////////////////////////

//to Test without Nathan:
a = NetAddr("127.0.0.1", 57120);

(
a.sendMsg("/init", 12, 2);

Routine.run({
   inf.do({arg i;
			a.sendMsg("/nodeMsg"++(i%12), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1));
			a.sendMsg("/global", 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1), 0.1.rrand(1));
       0.02.rrand(0.07).wait;
   })
})
)
a.sendMsg("/clear"); //Stop sound by using this



///////////////////////////////////////////////////////
